<!doctype html>
<!--[if IE 9]><html class="lt-ie10" lang="en" > <![endif]-->
<html class="no-js" lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <title>JavaScript Utilities | Foundation Docs</title>
    <link rel="icon" href="assets/img/icons/favicon.ico" type="image/x-icon">
    <!-- For third-generation iPad with high-resolution Retina display: -->
    <link rel="apple-touch-icon-precomposed" sizes="144x144" href="assets/img/icons/apple-touch-icon-144x144-precomposed.png">
    <!-- For iPhone with high-resolution Retina display: -->
    <link rel="apple-touch-icon-precomposed" sizes="114x114" href="assets/img/icons/apple-touch-icon-114x114-precomposed.png">
    <!-- For first- and second-generation iPad: -->
    <link rel="apple-touch-icon-precomposed" sizes="72x72" href="assets/img/icons/apple-touch-icon-72x72-precomposed.png">
    <!-- For non-Retina iPhone, iPod Touch, and Android 2.1+ devices: -->
    <link rel="apple-touch-icon-precomposed" href="assets/img/icons/apple-touch-icon-precomposed.png">

    <meta name="description" content="Documentation and reference library for ZURB Foundation. JavaScript, CSS, components, grid and more.">
    <meta name="author" content="ZURB, inc. ZURB network also includes zurb.com">
    <meta name="copyright" content="ZURB, inc. Copyright (c) 2014">

    <link href='assets/css/docs.css' rel='stylesheet' />
    <script src="assets/js/modernizr.js"></script>
  </head>
  <body class="antialiased hide-extras">
    <div class="marketing off-canvas-wrap" data-offcanvas>
      <div class="inner-wrap">

         <title>Foundation: The Most Advanced Responsive Front-end Framework from ZURB</title><meta name="description" content="Foundation from ZURB is the most advanced responsive front-end framework in the world." />
 

<!-- <nav class="tab-bar show-for-small">
  <a class="off-canvas-left-toggle menu-icon ">
    <span></span>
  </a>  
</nav> -->


<nav class="top-bar docs-bar hide-for-small" data-topbar>
  <ul class="title-area">
    <li class="name">
      <h1><a href="http://foundation.zurb.com/">Foundation</a></h1>
    </li>
  </ul>

  <section class="top-bar-section">
    <ul class="right">
      <li class="divider"></li>
      <li class="has-dropdown">
        <a href="http://foundation.zurb.com/learn/features.html" class="">Learn</a>
        <ul class="dropdown">
          <li><a href="http://foundation.zurb.com/learn/features.html">Features</a></li>
          <li><a href="http://foundation.zurb.com/learn/faq.html">FAQ</a></li>
          <li><a href="http://foundation.zurb.com/learn/case-washington-post.html">Case Studies</a></li>
          <li><a href="http://foundation.zurb.com/learn/website-examples.html">Website Examples</a></li>
          <li><a href="http://foundation.zurb.com/learn/video-started-with-foundation.html">Videos</a></li>
          <li><a href="http://foundation.zurb.com/learn/training.html">Training</a></li>
          <li><a href="http://foundation.zurb.com/learn/about.html">About</a></li>
        </ul>
      </li>
      <li class="divider"></li>
      <li class="has-dropdown">
        <a href="http://foundation.zurb.com/templates.html" class="">Develop</a>
        <ul class="dropdown">
          <li><a href="http://foundation.zurb.com/templates.html">Add-ons</a></li>
          <li><a href="http://foundation.zurb.com/docs">Docs</a></li>
          <li><a href="http://foundation.zurb.com/develop/download.html">Download</a></li>
          <li><a href="http://foundation.zurb.com/develop/contribute.html">Contribute</a></li>
          <li><a href="http://foundation.zurb.com/develop/tools.html">Tools</a></li>
        </ul>
      </li>
      <li class="divider"></li>
      <li class="has-dropdown">
        <a href="http://foundation.zurb.com/support/support.html" class="">Support</a>
        <ul class="dropdown">
          <li><a href="http://foundation.zurb.com/support/support.html">Support Channels</a></li>
          <li><a href="http://foundation.zurb.com/forum">Foundation Forum</a></li>
          <li><a href="http://foundation.zurb.com/support/images-and-badges.html">Images &amp; Badges</a></li>
        </ul>
      </li>
      <li class="divider"></li>
      <li>
        <a href="http://foundation.zurb.com/business/services.html" class="">Business</a>
      </li>
      <li class="divider"></li>
      <li>
        <a href="http://foundation.zurb.com/docs" class="">Docs</a>
      </li>
      <li class="divider"></li>
      <li class="has-form">
        <a href="http://foundation.zurb.com/docs" class="small button">Getting Started</a>
    </ul>
  </section>
</nav>
        <nav class="tab-bar show-for-small">
  <a class="left-off-canvas-toggle menu-icon">
    <span>Foundation</span>
  </a>
</nav>

<aside class="marketing-left-off-canvas-menu">

  <ul class="off-canvas-list">
    <li><label class="first">Foundation</label></li>
    <li><a href="http://foundation.zurb.com">Home</a></li>
  </ul>

  <hr>

  <ul class="off-canvas-list">
      <li><label>Setup</label></li>

      <li><a href="index.html" data-search="">Getting Started</a></li>
      <li><a href="css.html" data-search="Styles">CSS</a></li>
      <li><a href="sass.html" data-search="SCSS">Sass</a></li>
      <li><a href="applications.html" data-search="Rails,Gem">Applications</a></li>
      <li><a href="javascript.html" data-search="">Javascript</a></li>
      <li><a href="components/global.html" data-search="Global Styles,Global Mixins,Global Variables,Useful HTML Classes">Global Styles</a></li>
      <li><a href="components/kitchen_sink.html" data-search="">Kitchen Sink</a></li>
      <li><a href="upgrading.html" data-search="Migration">Upgrading</a></li>

      <li class="divider"></li>
      <li><label>Structure</label></li>
      <li><a href="media-queries.html" data-search="Breakpoints">Media Queries</a></li>
      <li><a href="components/visibility.html" data-search="">Visibility</a></li>
      <li><a href="components/grid.html" data-search="">Grid</a></li>
      <li><a href="components/block_grid.html" data-search="">Block Grid</a></li>
      <li><a href="components/interchange.html" data-search="Responsive Images">Interchange Responsive Content <span class="label">JS</span></a></li>
      <li><a href="utility-classes.html" data-search="">Utility Classes</a></li>
      <li><a href="javascript-utilities.html" data-search="">Javascript Utilities</a></li>
      <li><a href="components/rtl.html" data-search="RTL">Right-to-Left Support</a></li>

      <li class="divider"></li>
      <li><label>Navigation</label></li>
      <li><a href="components/offcanvas.html" data-search="Off Canvas">Offcanvas <span class="label">JS</span></a></li>
      <li><a href="components/topbar.html" data-search="Nav Bar,Navigation,Sticky">Top Bar <span class="label">JS</span></a></li>
      <li><a href="components/icon-bar.html" data-search="">Icon Bar</a></li>
      <li><a href="components/sidenav.html" data-search="">Side Nav</a></li>
      <li><a href="components/magellan.html" data-search="Scrollspy">Magellan Sticky Nav <span class="label">JS</span></a></li>
      <li><a href="components/subnav.html" data-search="">Sub Nav</a></li>
      <li><a href="components/breadcrumbs.html" data-search="Navigation Path,Cookie Crumb">Breadcrumbs</a></li>
      <li><a href="components/pagination.html" data-search="">Pagination</a></li>

      <li class="divider"></li>
      <li><label>Media</label></li>
      <li><a href="components/orbit.html" data-search="Carousel,Slider,Slideshow">Orbit Slider <span class="label">JS</span></a></li>
      <li><a href="components/thumbnails.html" data-search="Images">Thumbnails</a></li>
      <li><a href="components/clearing.html" data-search="Responsive Lightbox,Lightbox">Clearing Lightbox <span class="label">JS</span></a></li>
      <li><a href="components/flex_video.html" data-search="Responsive Video">Flex Video</a></li>

      <li class="divider"></li>
      <li><label>Forms</label></li>
      <li><a href="components/forms.html" data-search="">Forms</a></li>
      <li><a href="components/switch.html" data-search="">Switches</a></li>
      <li><a href="components/range_slider.html" data-search="Range Slider">Sliders <span class="label">JS</span></a></li>
      <li><a href="components/abide.html" data-search="Form Validation,Field Validation">Abide Validation <span class="label">JS</span></a></li>

      <li class="divider"></li>
      <li><label>Buttons</label></li>
      <li><a href="components/buttons.html" data-search="">Buttons</a></li>
      <li><a href="components/button_groups.html" data-search="Button Bar">Button Groups</a></li>
      <li><a href="components/split_buttons.html" data-search="">Split Buttons <span class="label">JS</span></a></li>
      <li><a href="components/dropdown_buttons.html" data-search="">Dropdown Buttons <span class="label">JS</span></a></li>

      <li class="divider"></li>
      <li><label>Typography</label></li>
      <li><a href="components/typography.html" data-search="Typography,Type-setting,Composition">Type</a></li>
      <li><a href="components/inline_lists.html" data-search="Lists">Inline Lists</a></li>
      <li><a href="components/labels.html" data-search="Tags">Labels</a></li>
      <li><a href="components/keystrokes.html" data-search="">Keystrokes</a></li>

      <li class="divider"></li>
      <li class="heading"><label>Callouts &amp; Prompts</label></li>
      <li><a href="components/reveal.html" data-search="Modal">Reveal Modal <span class="label">JS</span></a></li>
      <li><a href="components/alert_boxes.html" data-search="Error,Success,Warning">Alerts <span class="label">JS</span></a></li>
      <li><a href="components/panels.html" data-search="Wells">Panels</a></li>
      <li><a href="components/tooltips.html" data-search="Popover">Tooltips <span class="label">JS</span></a></li>
      <li><a href="components/joyride.html" data-search="Tooltip Tour,Guider,Tooltip Walk-through">Joyride <span class="label">JS</span></a></li>

      <li class="divider"></li>
      <li><label>Content</label></li>
      <li><a href="components/dropdown.html" data-search="">Dropdowns <span class="label">JS</span></a></li>
      <li><a href="components/pricing_tables.html" data-search="">Pricing Tables</a></li>
      <li><a href="components/progress_bars.html" data-search="">Progress Bars</a></li>
      <li><a href="components/tables.html" data-search="">Tables</a></li>
      <li><a href="components/accordion.html" data-search="">Accordion <span class="label">JS</span></a></li>
      <li><a href="components/tabs.html" data-search="">Tabs <span class="label">JS</span></a></li>
      <li><a href="components/equalizer.html" data-search="">Equalizer <span class="label">JS</span></a></li>

      <li class="divider"></li>
      <li><label>Support</label></li>

      <li><a href="changelog.html" data-search="">Changelog</a></li>
      <li><a href="compatibility.html" data-search="">Compatibility</a></li>

      <li class="divider"></li>
      <li class="heading"><label>Older Docs</label></li>
      <li><a href="/docs/v/4.3.2/" data-search="">Foundation 4</a></li>
      <li><a href="/docs/v/3.2.5/" data-search="">Foundation 3</a></li>
      <li><a href="/docs/v/2.2.1/" data-search="">Foundation 2</a></li>
    </ul>

    <hr>

    <div class="zurb-links">
    <ul class="top">
      <li class="logo"><a href="http://zurb.com"></a></li>
      <li><a href="http://zurb.com/about">About</a></li>
      <li><a href="http://zurb.com/blog">Blog</a></li>
      <li><a href="http://zurb.com/contact">Contact</a></li>
    </ul>
    <ul class="pillars">
      <li>
        <a href="http://www.zurb.com/studios" class="footer-link-block services">
          <span class="title">Studios</span>
          <span>Helping startups win since '98.</span>
        </a>
      </li>
      <li>
        <a href="http://foundation.zurb.com/" class="footer-link-block foundation">
          <span class="title">Foundation</span>
          <span>World's most advanced responsive framework.</span>
        </a>
      </li>
      <li>
        <a href="http://zurb.com/apps" class="footer-link-block apps">
          <span class="title">Design Apps</span>
          <span>Tools to rapidly prototype and iterate.</span>
        </a>
      </li>
      <li>
        <a href="http://zurb.com/university" class="footer-link-block expo">
          <span class="title">University</span>
          <span>Online training for smarter product design.</span>
        </a>
      </li>
    </ul>
</div>

  </ul>
</aside>

<a class="exit-off-canvas" href="#"></a>


        <section role="main" class="scroll-container">

          <div class="row">
            <div class="large-3 medium-4 columns">
              <div class="hide-for-small">
                <div class="sidebar">
  <h5>Foundation Documentation</h5>
  <form>
    <!--  <label>Search Documentation</label> -->
    <input tabindex="1" id="autocomplete" type="search" placeholder="Search Docs: e.g. forms">
  </form>

  <nav>
    <ul class="side-nav">
      <li class="heading">Setup</li>

      <li><a href="index.html" data-search="">Getting Started</a></li>
      <li><a href="css.html" data-search="Styles">CSS</a></li>
      <li><a href="sass.html" data-search="Sass">Sass</a></li>
      <li><a href="applications.html" data-search="Rails,Gem">Applications</a></li>
      <li><a href="javascript.html" data-search="">JavaScript</a></li>
      <li><a href="components/global.html" data-search="Global Styles,Global Mixins,Global Variables,Useful HTML Classes">Global Styles</a></li>
      <li><a href="components/kitchen_sink.html" data-search="">Kitchen Sink</a></li>
      <li><a href="upgrading.html" data-search="Migration">Upgrading</a></li>

      <li class="divider"></li>
      <li class="heading">Structure</li>
      <li><a href="media-queries.html" data-search="Breakpoints">Media Queries</a></li>
      <li><a href="components/visibility.html" data-search="">Visibility</a></li>
      <li><a href="components/grid.html" data-search="">Grid</a></li>
      <li><a href="components/block_grid.html" data-search="">Block Grid</a></li>
      <li><a href="components/interchange.html" data-search="Responsive Images">Interchange Responsive Content <span class="label">JS</span></a></li>
      <li><a href="utility-classes.html" data-search="">Utility Classes</a></li>
      <li><a href="javascript-utilities.html" data-search="">Javascript Utilities</a></li>
      <li><a href="components/rtl.html" data-search="RTL">Right-to-Left Support</a></li>

      <li class="divider"></li>
      <li class="heading">Navigation</li>
      <li><a href="components/offcanvas.html" data-search="Off Canvas">Offcanvas <span class="label">JS</span></a></li>
      <li><a href="components/topbar.html" data-search="Nav Bar,Navigation,Sticky">Top Bar <span class="label">JS</span></a></li>
      <li><a href="components/icon-bar.html" data-search="">Icon Bar</a></li>
      <li><a href="components/sidenav.html" data-search="">Side Nav</a></li>
      <li><a href="components/magellan.html" data-search="Scrollspy">Magellan Sticky Nav <span class="label">JS</span></a></li>
      <li><a href="components/subnav.html" data-search="">Sub Nav</a></li>
      <li><a href="components/breadcrumbs.html" data-search="Navigation Path,Cookie Crumb">Breadcrumbs</a></li>
      <li><a href="components/pagination.html" data-search="">Pagination</a></li>

      <li class="divider"></li>
      <li class="heading">Media</li>
      <li><a href="components/orbit.html" data-search="Carousel,Slider,Slideshow">Orbit Slider <span class="label">JS</span></a></li>
      <li><a href="components/thumbnails.html" data-search="Images">Thumbnails</a></li>
      <li><a href="components/clearing.html" data-search="Responsive Lightbox,Lightbox">Clearing Lightbox <span class="label">JS</span></a></li>
      <li><a href="components/flex_video.html" data-search="Responsive Video">Flex Video</a></li>

      <li class="divider"></li>
      <li class="heading">Forms</li>
      <li><a href="components/forms.html" data-search="">Forms</a></li>
      <li><a href="components/switch.html" data-search="">Switches</a></li>
      <li><a href="components/range_slider.html" data-search="Range Slider">Range Sliders <span class="label">JS</span></a></li>
      <li><a href="components/abide.html" data-search="Form Validation,Field Validation">Abide Validation <span class="label">JS</span></a></li>

      <li class="divider"></li>
      <li class="heading">Buttons</li>
      <li><a href="components/buttons.html" data-search="">Buttons</a></li>
      <li><a href="components/button_groups.html" data-search="Button Bar">Button Groups</a></li>
      <li><a href="components/split_buttons.html" data-search="">Split Buttons <span class="label">JS</span></a></li>
      <li><a href="components/dropdown_buttons.html" data-search="">Dropdown Buttons <span class="label">JS</span></a></li>

      <li class="divider"></li>
      <li class="heading">Typography</li>
      <li><a href="components/typography.html" data-search="Typography,Type-setting,Composition">Type</a></li>
      <li><a href="components/inline_lists.html" data-search="Lists">Inline Lists</a></li>
      <li><a href="components/labels.html" data-search="Tags">Labels</a></li>
      <li><a href="components/keystrokes.html" data-search="">Keystrokes</a></li>

      <li class="divider"></li>
      <li class="heading">Callouts &amp; Prompts</li>
      <li><a href="components/reveal.html" data-search="Modal">Reveal Modal <span class="label">JS</span></a></li>
      <li><a href="components/alert_boxes.html" data-search="Error,Success,Warning">Alerts <span class="label">JS</span></a></li>
      <li><a href="components/panels.html" data-search="Wells">Panels</a></li>
      <li><a href="components/tooltips.html" data-search="Popover">Tooltips <span class="label">JS</span></a></li>
      <li><a href="components/joyride.html" data-search="Tooltip Tour,Guider,Tooltip Walk-through">Joyride <span class="label">JS</span></a></li>

      <li class="divider"></li>
      <li class="heading">Content</li>
      <li><a href="components/dropdown.html" data-search="">Dropdowns <span class="label">JS</span></a></li>
      <li><a href="components/pricing_tables.html" data-search="">Pricing Tables</a></li>
      <li><a href="components/progress_bars.html" data-search="">Progress Bars</a></li>
      <li><a href="components/tables.html" data-search="">Tables</a></li>
      <li><a href="components/accordion.html" data-search="">Accordion <span class="label">JS</span></a></li>
      <li><a href="components/tabs.html" data-search="">Tabs <span class="label">JS</span></a></li>
      <li><a href="components/equalizer.html" data-search="">Equalizer <span class="label">JS</span></a></li>

      <li class="divider"></li>
      <li class="heading">Support</li>

      <li><a href="changelog.html" data-search="">Changelog</a></li>
      <li><a href="compatibility.html" data-search="">Compatibility</a></li>

      <li class="divider"></li>
      <li class="heading">Older Docs</li>
      <li><a href="/docs/v/4.3.2/" data-search="">Foundation 4</a></li>
      <li><a href="/docs/v/3.2.5/" data-search="">Foundation 3</a></li>
      <li><a href="/docs/v/2.2.1/" data-search="">Foundation 2</a></li>

    </ul>
  </nav>

  <a href="/develop/download.html" class="download button expand">Download Foundation</a>

  <section id="jobs">
    <h5>Get a job, nerd!</h5>
    <script type="text/javascript" src="http://www.zurb.com/jobs/widgets/jobs.js?limit=3"></script>
    <p class="via">via <a href="http://www.zurb.com/jobs">Job Board from ZURB</a></p>
  </section>

</div>
              </div>
            </div>
            <div class="large-9 medium-8 columns">
              <h1 id="javascript-utilities">JavaScript Utilities</h1>
              <h3 class="subheader">Foundation includes a handful of helpful JavaScript utilities to help you add common functionalities to your apps and plugins.</h3>

<hr>
<h3 id="using">Using the JavaScript Utilities</h3>

<p>There are two ways to use the Foundation utilities: by calling them within the Foundation.utils namespace and by inheriting them into an object.</p>
<h4>Foundation.utils</h4>

<p>As long as <kbd>foundation.js</kbd> has been loaded into the page, you can access any of the Foundation utilities by calling <code>Foundation.utils.{function_name}</code>.</p>
<p>For example, if you type the following into the JavaScript console it will return a 6-digit alphanumeric string.</p>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Generates a random string of length n</span>
Foundation.utils.random_str(<span class="number">6</span>);</div></code></pre>


<h4>Method Inheritance</h4>

<p>If you have any plain ole&#8217; JavaScript object (a POJO), then you can inherit any of the Foundation JavaScript utilities by calling the <code>Foundation.inherit</code> method. To use the inherit method, pass in the object you want to inherit the methods, followed by a space separated string of methods that you want to inherit.</p>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Simple example</span>
<span class="keyword">var</span> user = {};
Foundation.inherit(user, <span class="string">'random_str data_options'</span>);

<span class="comment">// Advanced Example</span>
Person = <span class="keyword">function</span>() {
  <span class="keyword">this</span>.init = <span class="keyword">function</span>() {
    Foundation.inherit(<span class="keyword">this</span>, <span class="string">'random_str data_options'</span>);
  }
};

<span class="keyword">var</span> user = <span class="keyword">new</span> Person();
user.init();</div></code></pre>



<hr>
<h3 id="selector">Selector Engine</h3>

<p>While jQuery&#8217;s selector engine is quite versatile, it can sometimes be a bit slow. Foundation&#8217;s &#8220;Big S&#8221; selector leverages the native browser API by using <code>querySelectorAll()</code>, making it up to 20% faster.</p>
<p>&#8220;Big S&#8221; can be used as a drop-in replacement for the jQuery $ selector in most cases.</p>
<div class="row">
  <div class="large-6 columns">
    <h4>jQuery Selector</h4>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// A simple selector</span>
$(<span class="string">&#39;.class #id&#39;</span>);

<span class="comment">// A bracket selector</span>
$(<span class="string">&#39;label[for=&quot;input1&quot;]&#39;</span>);

<span class="comment">// A scoped selector</span>
$(<span class="string">&#39;dd &gt; .content&#39;</span>, <span class="string">&#39;#accordion&#39;</span>);</div></code></pre>

  </div>
  <div class="large-6 columns">
    <h4>&#8220;Big S&#8221; Selector</h4>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// A simple selector</span>
Foundation.utils.S(<span class="string">&#39;.class #id&#39;</span>);

<span class="comment">// A bracket selector</span>
Foundation.utils.S(<span class="string">&#39;label[for=&quot;input1&quot;]&#39;</span>);

<span class="comment">// A scoped selector</span>
Foundation.utils.S(<span class="string">&#39;dd &gt; .content&#39;</span>, <span class="string">&#39;#accordion&#39;</span>);</div></code></pre>

  </div>
</div>

<p><h4>Method Signature</h4></p>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Arguments:</span>
<span class="comment">//    Selector (String): CSS selector describing the element(s) to be</span>
<span class="comment">//    returned as a jQuery object.</span>
<span class="comment">//</span>
<span class="comment">//    Scope (String): CSS selector describing the area to be searched. Default</span>
<span class="comment">//    is document.</span>
<span class="comment">//</span>
<span class="comment">// Returns:</span>
<span class="comment">//    Element (jQuery Object): jQuery object containing elements matching the</span>
<span class="comment">//    selector within the scope.</span>

S(selector, scope) { ... }</div></code></pre>


<hr>
<h3 id="delay">Throttle &amp; Debounce</h3>

<p>Many times when you create a callback, it&#8217;s advantageous to add a delay in order to prevent it from being triggered multiple times. Foundation includes two types of callback delays: <code>throttle</code> and <code>debounce</code>.</p>
<p><strong>Throttle</strong> prevents a function from being executed more than once every n milliseconds. Throttling is often used in cases where it&#8217;s disadvantageous to trigger a callback every time an event is triggered (during a continuous action), but you still want to trigger a reaction while the event is occurring. Examples of this would be reacting to the browser window being resized, or animating an element.</p>
<p><strong>Debounce</strong> prevents a function from being executed until it stops being invoked for n milliseconds. Debouncing is often used to prevent an action from being performed twice, such as double clicking a submit button, or to delay an event from occurring accidentally, such as an event triggered by hover.</p>
<div class="row">
  <div class="large-6 columns">
    <h4>Without Delay</h4>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Button click handler</span>
$(<span class="string">&#39;.button&#39;</span>).on(<span class="string">&#39;click&#39;</span>, <span class="keyword">function</span>(e){
  <span class="comment">// Handle Click</span>
});

<span class="comment">// Resize function</span>
$(window).on(<span class="string">&#39;resize&#39;</span>, <span class="keyword">function</span>(e){
  <span class="comment">// Do responsive stuff</span>
});</div></code></pre>

  </div>
  <div class="large-6 columns">
    <h4>With Delay</h4>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Debounced button click handler</span>
$(<span class="string">&#39;.button&#39;</span>).on(<span class="string">&#39;click&#39;</span>, Foundation.utils.debounce(<span class="keyword">function</span>(e){
  <span class="comment">// Handle Click</span>
}, <span class="number">300</span>, <span class="literal">true</span>));

<span class="comment">// Throttled resize function</span>
$(window).on(<span class="string">&#39;resize&#39;</span>, Foundation.utils.throttle(<span class="keyword">function</span>(e){
  <span class="comment">// Do responsive stuff</span>
}, <span class="number">300</span>));</div></code></pre>

  </div>
</div>

<p><h4>Method Signature</h4></p>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Arguments:</span>
<span class="comment">//    Func (Function): Function to be throttled.</span>
<span class="comment">//</span>
<span class="comment">//    Delay (Integer): Function execution threshold in milliseconds.</span>
<span class="comment">//</span>
<span class="comment">// Returns:</span>
<span class="comment">//    Lazy_function (Function): Function with throttling applied.</span>

throttle(func, delay) { ... }

<span class="comment">// Arguments:</span>
<span class="comment">//    Func (Function): Function to be debounced.</span>
<span class="comment">//</span>
<span class="comment">//    Delay (Integer): Function execution threshold in milliseconds.</span>
<span class="comment">//</span>
<span class="comment">//    Immediate (Bool): Whether the function should be called at the beginning</span>
<span class="comment">//    of the delay instead of the end. Default is false.</span>
<span class="comment">//</span>
<span class="comment">// Returns:</span>
<span class="comment">//    Lazy_function (Function): Function with debouncing applied.</span>

debounce(func, delay, immediate) { ... }</div></code></pre>


<hr>
<h3 id="data-options">Data Options</h3>

<p>The <code>data_options</code> method parses a semicolon delimited set of values in the selected element&#8217;s <code>data-options</code> HTML attribute. It&#8217;s useful for allowing settings to be passed into a script or plugin from the markup.</p>
<div class="row">
  <div class="large-6 columns">
    <h4>HTML</h4>
<pre><code class="language-html"><div class="code-container"><span class="tag">&lt;<span class="title">div</span> <span class="attribute">id</span>=<span class="value">&quot;target&quot;</span> <span class="attribute">data-options</span>=<span class="value">&quot;delay:4;color:red;animal:unicorn&quot;</span>&gt;</span><span class="tag">&lt;/<span class="title">div</span>&gt;</span></div></code></pre>

  </div>
  <div class="large-6 columns">
    <h4>Javascript</h4>
<pre><code class="language-javascript"><div class="code-container"><span class="keyword">var</span> settings = Foundation.utils.data_options($(<span class="string">&#39;#target&#39;</span>));</div></code></pre>

  </div>
</div>

<p><h4>Method Signature</h4></p>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Arguments:</span>
<span class="comment">//    el (jQuery Object): Element to be parsed.</span>
<span class="comment">//    data_attr_name (string): Optional name of the data attribute containing the options string (defaults to 'options').</span>
<span class="comment">//</span>
<span class="comment">// Returns:</span>
<span class="comment">//    Options (Javascript Object): Contents of the element's data-options</span>
<span class="comment">//    attribute.</span>

data_options(el, data_attr_name) { ... }</div></code></pre>


<hr>
<h3 id="media-queries">Media Queries</h3>

<p>Media queries are the backbone of most responsive CSS techniques, though they can be a bit unwieldy to deal with. To make them easier to deal with, we&#8217;ve included two helper methods (<code>register_media</code> and <code>add_custom_rule</code>), as well as polyfilled the native function <code>matchMedia</code> to work with all the browsers Foundation supports.</p>
<p><strong>Register Media</strong> is used to add a new media query to Foundation&#8217;s list of JavaScript-accessible media queries. These can be found by calling <code>Foundation.media_queries</code>. The method works by appending a meta tag to the head of the document and checking the <code>font-family</code> of the element&#8217;s computed styles for the media query string.</p>
<p><strong>Add Custom Rules</strong> is a method to add a custom CSS rule as a string to the document. If a media query is passed in the method will apply the style within that media query, otherwise it will be applied globally.</p>
<p><strong>Match Media</strong> can be used to check if the browser currently matches the media query passed in as a string. To use the function, call <code>matchMedia()</code> with the media query as an argument, and check the <code>matches</code> property (see example below).</p>
<div class="row">
  <div class="large-6 columns">
    <h4>CSS</h4>
<pre><code class="language-css"><div class="code-container"><span class="comment">/<em>
</em> Note: The media query string in the font-family property has to be surrounded
<em> by slashes to be recognized by Phantom.js
</em>
<em> Note: Instead of being defined in the CSS, the following style rule could also
</em> be added to the document using Foundation.utils.add_custom_rule().
*/</span>
<span class="tag">meta</span><span class="class">.my-mq-custom</span> <span class="rules">{
  <span class="rule"><span class="attribute">font-family</span>:<span class="value"> <span class="string">&quot;/only screen and (min-width: 40em)/&quot;</span>;</span></span>
  <span class="rule"><span class="attribute">width</span>:<span class="value"> <span class="number">40</span>em;</span></span>
<span class="rule">}</span></span></div></code></pre>

  </div>
  <div class="large-6 columns">
    <h4>Javascript</h4>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Register custom media query</span>
Foundation.utils.register_media(<span class="string">&#39;custom&#39;</span>, <span class="string">&#39;my-mq-custom&#39;</span>);

<span class="comment">// Check if the media query is activated</span>
<span class="keyword">if</span> (matchMedia(Foundation.media_queries[<span class="string">&#39;custom&#39;</span>]).matches){
  ...
};

<span class="comment">// Apply a custom CSS rule to the media query</span>
Foundation.utils.add_custom_rule(<span class="string">&#39;.js-generated-element { padding-top: &#39;</span> + element.data(<span class="string">&#39;height&#39;</span>) + <span class="string">&#39;px }&#39;</span>, <span class="string">&#39;custom&#39;</span>);</div></code></pre>

  </div>
</div>

<p><h4>Method Signature</h4></p>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Arguments:</span>
<span class="comment">//    Media (String): Key string for the media query to be stored as in</span>
<span class="comment">//    Foundation.media_queries</span>
<span class="comment">//</span>
<span class="comment">//    Class (String): Class name for the generated &lt;meta&gt; tag</span>

register_media(media, class) { ... }

<span class="comment">// Arguments:</span>
<span class="comment">//    Rule (String): CSS rule to be appended to the document.</span>
<span class="comment">//</span>
<span class="comment">//    Media (String): Optional media query string for the CSS rule to be</span>
<span class="comment">//    nested under.</span>

add_custom_rule(rule, media) { ... }</div></code></pre>


<hr>
<h3 id="image-loaded">Image Loaded</h3>

<p>While binding to the document ready event is usually good enough for most plugins that manipulate the DOM, sometimes you need ALL the content to be loaded before you start calculating things like element sizes. This is especially important with images, which can take a while to load and significantly affect the layout of the page, depending on their size.</p>
<p>This can be avoided by using the <code>image_loaded</code> method, which lets you pass in a callback to be executed when an image has completely finished loading. Passing in a jQuery selector that matches multiple images will cause the callback to be executed when all of the images are fully loaded.</p>
<p><h4>Example</h4></p>
<pre><code class="language-javascript"><div class="code-container">Foundation.utils.image_loaded($(<span class="string">'img.wait-for-me'</span>), <span class="keyword">function</span>(){
  console.log(<span class="string">'Image Loaded! :)'</span>);
});</div></code></pre>


<p><h4>Method Signature</h4></p>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Arguments:</span>
<span class="comment">//    Image (jQuery Object): Image(s) to check if loaded.</span>
<span class="comment">//</span>
<span class="comment">//    Callback (Function): Foundation to execute when image is fully loaded.</span>

image_loaded(image, callback) { ... }</div></code></pre>


<hr>
<h3 id="random">Random String</h3>

<p>The <code>random_str</code> method is a helper for generating random strings of a given length. This method is used by some of the Foundation plugins to ensure a reasonable probability of non-collision for IDs in dynamically generated DOM objects. Note that <code>random_str</code> should not be considered cryptographically secure.</p>
<p><h4>Example</h4></p>
<pre><code class="language-javascript"><div class="code-container">&gt;&gt; Foundation.utils.random_str(<span class="number">6</span>);
<span class="string">"P47PGD"</span>
&gt;&gt; Foundation.utils.random_str(<span class="number">6</span>);
<span class="string">"JvuXFc"</span>
&gt;&gt; Foundation.utils.random_str(<span class="number">6</span>);
<span class="string">"XOxB7j"</span></div></code></pre>


<p><h4>Method Signature</h4></p>
<pre><code class="language-javascript"><div class="code-container"><span class="comment">// Arguments:</span>
<span class="comment">//    Length (Integer): Length of string to be generated. Defaults to random</span>
<span class="comment">//    integer.</span>
<span class="comment">//</span>
<span class="comment">// Returns:</span>
<span class="comment">//    Rand (String): Pseudo-random, alphanumeric string.</span>

random_str(length) { ... }</div></code></pre>



            </div>
          </div>
          <section id="courses-banner-large">
  <div class="row">
    <div class="large-5 medium-5 columns banner-image">
      <img src="http://foundation.zurb.com/assets/img/responsive-banner-main.svg" alt="responsive design">
    </div>
    <div class="large-7 medium-7 columns banner-info">
      <h3>Get a running start with Foundation</h3>
      <p>Learn the fundamentals of the world's most advanced responsive framework in our <strong>Intro to Foundation class.</strong> You'll learn from the creators themselves on how to use Foundation and jumpstart your next project. <a href="http://zurb.com/university/courses" class="inline-hide">Learn more about classes »</a></p>
      <a href="http://zurb.com/university/foundation-intro?utm_source=Foundation%20Docs&utm_medium=Large%20Banner&utm_campaign=Intro%20to%20Foundation" class="button">Learn More</a>
      <a href="http://zurb.com/university/courses" class="learn-more hide-for-medium-up">Learn more about classes »</a>
    </div>
  </div>
</section>
          <div id="newsletter">
  <div class="row">
    <div class="medium-8 columns">
      <h5>Stay on top of what&rsquo;s happening in <a href="http://zurb.com/responsive">responsive design</a>.</h5>
      <p>Sign up to receive monthly Responsive Reading highlights. <a href="http://zurb.com/responsive/reading">Read Last Month's Edition &raquo;</a></p>
    </div>
    <div class="medium-4 columns">
      <form method="post" action="http://zurb.com/responsive/subscribe">
        <div class="row collapse margintop-20px">
          <div class="small-8 medium-8 columns">
            <input type="text" name="email" placeholder="signup@example.com">
          </div>
          <div class="small-4 medium-4 columns">
            <input type="submit" href="#" class="postfix small button expand" value="Sign Up">
          </div>
        </div>
      </form>
    </div>
  </div>
</div>


<div class="zurb-footer-top bg-fblue">
  <div class="row property">
    <div class="medium-4 columns">
      <div class="property-info">
        <h3>Foundation</h3>
        <p>Foundation is made by <a href="http://zurb.com">ZURB, a product design</a> company in Campbell, California. We've put more than 15 years of experience building web products, services and websites into this framework.
        </p>
      </div>
    </div>

    <div class="medium-8 columns">
      <div class="row collapse">
        <div class="medium-4 columns">
          <div class="learn-links">
            <h4 class="hide-for-small">Want more?</h4>
            <ul>
              <li><a href="http://foundation.zurb.com/business/services.html">Foundation Business</a></li>
              <li><a href="http://zurb.com/responsive">Responsive</a></li>
              <li><a href="http://zurb.com/apps">Design Apps</a></li>
              <li><a href="http://foundation.zurb.com/learn/training.html">Foundation Training</a></li>
            </ul>
          </div>
        </div>
          <div class="medium-4 columns">
            <div class="support-links">
              <h4 class="hide-for-small">Talk to us</h4>
              <p>Tweet us at <br> <a href="https://twitter.com/foundationzurb">@foundationzurb</a></p>
              <p>Email us at <br> <a href="mailto:foundation@zurb.com">foundation@zurb.com</a><br> or check our <a href="../support/support.html">support page</a></p>
            </div>
          </div>
        <div class="medium-4 columns">
          <div class="connect-links">
            <h4 class="hide-for-small">Stay in touch</h4>
            <p>Keep up with the latest on Foundation. Find us on <a href="https://github.com/zurb/foundation">Github</a>.</p>
            <a href="http://zurb.com/news" class="small button">Stay Connected</a>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="row global">
    <div class="medium-3 small-6 columns">
      <a href="http://zurb.com/studios" class="footer-link-block services">
        <span class="title">Studios</span>
        <span>Helping more than 200 startups succeed since 1998.</span>
      </a>
    </div>
    <div class="medium-3 small-6 columns">
      <a href="http://foundation.zurb.com/" class="footer-link-block foundation">
        <span class="title">Foundation</span>
        <span>The most advanced front-end framework in the world.</span>
      </a>
    </div>
    <div class="medium-3 small-6 columns">
      <a href="http://zurb.com/apps" class="footer-link-block apps">
        <span class="title">Design Apps</span>
        <span>Prototype, iterate and collect feedback on your products.</span>
      </a>
    </div>
    <div class="medium-3 small-6 columns">
      <a href="http://zurb.com/university" class="footer-link-block expo">
        <span class="title">University</span>
        <span>Ideas, thoughts and design resources shared with you.</span>
      </a>
    </div>
  </div>
</div>

<div class="zurb-footer-bottom">
  <div class="row">
    <div class="medium-4 medium-4 push-8 columns">
      <ul class="home-social">
          <li><a href="http://www.twitter.com/ZURB" class="twitter"></a></li>
          <li><a href="http://www.facebook.com/ZURB" class="facebook"></a></li>
          <li><a href="http://zurb.com/contact" class="mail"></a></li>
        </ul>
     </div>
     <div class="medium-8 medium-8 pull-4 columns">
        <a href="http://www.zurb.com" class="zurb-logo regular"></a>
        <ul class="zurb-links">
          <li><a href="http://zurb.com/about">About</a></li>
          <li><a href="http://zurb.com/blog">Blog</a></li>
          <li><a href="http://zurb.com/news">News<span class="show-for-medium-up"> &amp; Events</span></a></li>
          <li><a href="http://zurb.com/contact">Contact</a></li>
          <li><a href="http://zurb.com/sitemap">Sitemap</a></li>
       </ul>
       <p class="copyright">&copy; 1998&dash;2014 ZURB, Inc. All rights reserved.</p>
    </div>
  </div>
</div>

        </section>

      </div>
    </div>

    <script src="assets/js/templates.js"></script>
    <script src="assets/js/all.js"></script>
    <script>
      var _gaq = _gaq || [];
      _gaq.push(
        ['_setAccount', 'UA-2195009-2'],
        ['_trackPageview'],
        ['b._setAccount', 'UA-2195009-27'],
        ['b._trackPageview']
      );

      (function() {
        var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
        ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
        var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
      })();
    </script>
    <script>
      $(document).foundation().foundation('joyride', 'start');
    </script>
  </body>
</html>
